(set-logic QF_SLIA)
(set-option :incremental true)
(declare-fun s () String)
(define-const a RegLan (str.to_re "a"))
(define-const b RegLan (str.to_re "b"))
;; anbm := L(a*b*)
(define-const anbm RegLan
  (re.++ (re.* a) (re.* b))
)

;; s="" => s in L(a*b*)
(assert
  (and
    (= s "")
    (not (str.in_re s anbm))
  )
)
(check-sat)
;; s in L(a*b*) AND |s| < 10 => "a"++s++"b" in L(a*b*)
(assert 
  (and
    (str.in_re s anbm)
    (< (str.len s) 10)
    (not (str.in_re (str.++ "a" s "b") anbm))
  )
)
(check-sat)
;; s in L(a*b*) AND |s| >= 10 => s not in L([ab]*ba[ab]*)
(assert
  (and
    (str.in_re s anbm)
    (>= (str.len s) 10)
    (not(not (str.in_re s 
      (re.++ (re.union a b) b a (re.union a b))
    )))
  )
)
(check-sat)
